/**
 * vim: set ts=4 sw=4 tw=99 noet :
 * ======================================================
 * Metamod:Source
 * Copyright (C) 2004-2024 AlliedModders LLC and authors.
 * All rights reserved.
 * ======================================================
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from 
 * the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose, 
 * including commercial applications, and to alter it and redistribute it 
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not 
 * claim that you wrote the original software. If you use this software in a 
 * product, an acknowledgment in the product documentation would be 
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 */

#ifndef _INCLUDE_METAMOD_VERSION_INFORMATION_H_
#define _INCLUDE_METAMOD_VERSION_INFORMATION_H_

/**
 * @file Contains Metamod version information.
 * @brief This file will redirect to an autogenerated version if being compiled via
 * the build scripts.
 */

#if defined MMS_GENERATED_BUILD
# if defined RC_COMPILE
#  undef MMS_USE_VERSIONLIB
# endif
# if defined MMS_USE_VERSIONLIB
#  include <versionlib.h>
# else 
#  include <metamod_version_auto.h>
# endif
#else
#define MMS_BUILD_TAG		"manual"
#define MMS_BUILD_LOCAL_REV	"0"
#define MMS_BUILD_CSET		"0"
#define MMS_BUILD_MAJOR		"2"
#define MMS_BUILD_MINOR		"0"
#define MMS_BUILD_RELEASE	"0"

#define MMS_BUILD_UNIQUEID MMS_BUILD_LOCAL_REV ":" MMS_BUILD_CSET

#define MMS_VERSION_STRING	MMS_BUILD_MAJOR "." MMS_BUILD_MINOR "." MMS_BUILD_RELEASE "-" MMS_BUILD_TAG
#define MMS_VERSION_FILE		2,0,0,0
#endif
#define MMS_BUILD_TIMESTAMP	__DATE__ " " __TIME__

#if !defined(MMS_GENERATED_BUILD) || !defined(MMS_USE_VERSIONLIB)
# define METAMOD_VERSION 		MMS_VERSION_STRING
# define METAMOD_BUILD_ID		MMS_BUILD_UNIQUEID
# define METAMOD_BUILD_TIME 	MMS_BUILD_TIMESTAMP
#endif

#endif /* _INCLUDE_METAMOD_VERSION_INFORMATION_H_ */

